#!/bin/sh
#
# $Header: /CVSROOT/public/scylla-charybdis/md5backup/bin/sc-mysql.sh,v 1.4 2004/07/05 18:11:24 tino Exp $
#
# $Log: sc-mysql.sh,v $
# Revision 1.4  2004/07/05 18:11:24  tino
# some more logging in bin/sc-*.sh
#
# Revision 1.3  2004/07/03 12:55:03  tino
# working version commit
#
# Revision 1.2  2004/05/15 14:42:47  tino
# updated
#
# Revision 1.1  2004/05/04 05:11:01  tino
# sc-backup.sh: backup via scylla+charybis; dobackup.sh convenience script

# Dirty test if mysql is installed
if [ ! -x /usr/bin/mysqldump ]
then
	echo "mysql not installed, skipping mysql backup"
	exit 0
fi
TARG="$1"
if [ -z "$TARG" ]
then
	echo "Usage: `basename "$0"` /base/path [mysql-root-pw]" >&2
	exit 1
fi

log()
{
loga="$1"
shift
printf "%s: $loga\n" "`date +'%Y-%m-%d %H:%M:%S'`" "$@" >> "tmp/log.$TARG"
}

[ -d "$TARG/mysql" ] || mkdir "$TARG/mysql" || exit 1
OUT="$TARG/mysql/`hostname -f`-`date +%Y%m%d-%H%M%S`.sql"

echo "Backing up mysql database."
MYPW="$2"
if [ -z "$MYPW" ]
then
	read -esp "Please enter your mysql root password:" MYPW || exit 1
fi
# I really dislike to see passwords on the command line.
# They shall not be seen in environment either.
# However as mysql insists of reading it from the tty
# we have no other choice.  That's really bad design of mysql!
/usr/bin/mysqldump -a -A -c -e -F -hlocalhost -uroot --password="$MYPW" > "$OUT" &&
bzip2 -9 "$OUT" &&
log "mysql dumped, %d bytes" `wc -c < "$OUT.bz2"`
